#!/usr/bin/env python
# -*- coding: utf-8 -*- 
import csv
import urllib2
import urlparse
import urllib2
from lxml import etree
import re
from math import *
from models import *
from mongoengine import *
#from neo4django import *
from django.core.files import File
import threading
from py2neo import neo4j, cypher
from dbQuerys import *
from django.http import HttpResponse

class Crawler:


	def __init__(self,domain):

		self.xpath=[]
		self.domain = ""
		self.exitProces = False



	#Main method for websites parsing
	def main(self, urlBase, xpath):
		self.exitProces = False
		totalObtainedUrls = {}
		recipes = []
		self.domain = urlBase
		startUrl = "http://"+self.domain+"/"
		self.crawlUrl(startUrl,totalObtainedUrls, recipes, xpath)
		print "FINAL"+self.domain


	#Download and return a Html document from an url
	def getHtmlDocument(self, url):
		urlFile = urllib2.urlopen(url)
		htmlCode = urlFile.read()
		urlFile.close()
		return htmlCode

	#This method get all html tags and css classes that will become the XPath
	def checkNodes(self,nodes, tree, ingredientsNumber):
		actualXpath = ""
		validResult = False
		for node in nodes:
			nodeTree=[node]
			actualNode=node
			#12 is the maximum amout of concatenated tags in case of no css class
			while not validResult and len(nodeTree)<12:
				tagName = nodeTree[-1].tag
				try:
					cssClass =  nodeTree[-1].attrib
				except:
					cssClass = {}
				#If css class exist, eassy solution
				if (cssClass and True) or False:
					nodeTree[-1] = (cssClass,'css')
					nodeTree.append((tagName,'tag'))
				#Else tag concatenation
				else:
					nodeTree[-1] = (tagName,'tag')
				print nodeTree
				xpathCandidate= self.generateValidXpath(nodeTree, ingredientsNumber, tree)
				if xpathCandidate:
					validResult=True
					return xpathCandidate
				nodeTree.append(actualNode.getparent())
				actualNode=actualNode.getparent()


	#This method generate the XPath from the data obtained in the checkNodes method
	def generateValidXpath(self,nodeTree, ingredientsNumber, tree):
		actualXpath="/"
		if len(nodeTree)>1: nodeTree = nodeTree[::-1]
		for e in nodeTree:
			if e[1]=='tag':
				actualXpath+="/"+e[0]
			else:
				actualXpath+="[@"+e[0].keys()[0]+"='"+e[0].values()[0]+"']"
		actualXpath+="/text()"
		if len(tree.xpath(actualXpath))>=ingredientsNumber and len(tree.xpath(actualXpath))<ingredientsNumber*2:
			return actualXpath
		return None



	#This is the main method for get the xpath, it extracts the root
	#xpath node where is located de recipe and then call checkNodes method
	def getXpath(self,ingredients, recipeUrl):
		count = 0
		for url in recipeUrl:
			try:
				condIngredientsValid = True
				#UrlRead
				response = urllib2.urlopen(url)
				htmlparser = etree.HTMLParser()
				tree = etree.parse(response, htmlparser)
				#Some times list element end with space, so it shoudl be deleted '[0:-1]'
				ingredientSelected=0
				condIngredientSelected=False
				#Get a ingredient just composed by ascii characters
				while not condIngredientSelected:
					for c in ingredients[count][ingredientSelected]: 
						if 0 < ord(c) < 127:
							condIngredientSelected=True
						else:
							condIngredientSelected=False
							ingredientSelected+=1
							break
					#No ingredient valid, no ingredients reamaining
					if ingredientSelected==len(ingredients[count]):
						condIngredientSelected=True
						condIngredientsValid = False
				#Check if the selected ingredient ends with a space
				if condIngredientsValid:
					if " " in ingredients[count][ingredientSelected][-1]:
						ingredient = ingredients[count][ingredientSelected][:-1]
					else: ingredient = ingredients[count][ingredientSelected]
					validNode = True
					#While there is not a valid node...
					while validNode:
						#Check if the selected ingredient starts with a space
						if " " in ingredient[0]:
							ingredient = ingredient[1:]
						ingredientXpath = ''.join(['//*[contains(text(), "'+ingredient+'")]'])
						node = tree.xpath(ingredientXpath)
						#If the result !=Null we have a valid node, exit bucle
						if len(node)!=0:
							validNode=False
						#Else remove last word
						else:
							ingredient = ingredient[1:]
					if not ingredient == "":
						xpathCandidate = self.checkNodes(node, tree, len(ingredients[count]))
						if xpathCandidate not in self.xpath: 
							self.xpath.append(xpathCandidate)
				count+=1
			except:
				return None

	#This method start the web crawler
	def crawlUrl(self, urlPagina, totalObtainedUrls, recipes, xpath):
		print "XPATH"
		print self.xpath
		count = 0
		recipesCount=0
		urlsToParse = [urlPagina]
		graph_db = neo4j.GraphDatabaseService()		
		#query = "MATCH (n) WHERE HAS (n.group)  RETURN count(n)"
		#numIngredients=cypher.execute(graph_db, query)[0][0][0]
		numIngredients=0
		while urlsToParse and not self.exitProces:
			count+=1
			try:
				urlPagina = urlsToParse.pop(0)
				if not urlPagina.startswith('http://'):
					urlPagina= "http://" + self.domain + urlPagina 
				link = urlPagina
				if not HtmlDocument.objects(url=link):
					html = HtmlDocument(url=link, xpath=xpath[0])
					html.save()	
					print "html saved"
				print "urls",count,"-",urlPagina
			except:
				print "URL ERROR ",count
				totalObtainedUrls[urlPagina]=0
			try:
				htmlparser = etree.HTMLParser()
				response = urllib2.urlopen(urlPagina)
				tree = etree.parse(response,htmlparser)
				recipe = self.parseItemsLxml(tree)
				if recipe:
					recipesCount+=1
					print "Recipe found",recipesCount
					if not CrudeRecipe.objects(url=link):
						crudeRecipe = CrudeRecipe(url=link,name=link.split("/")[-1], ingredients=recipe)
						crudeRecipe.save()
						recipeNeo, = graph_db.create({"name": link.split("/")[-1], "url": link})
						ingredientsRecipeList = list()
						for ingredient in self.getIngredientsFromRecipe(recipe):
							query = "MATCH (n) WHERE n.identificator = '"+str(ingredient[2])+"' RETURN n"
							ingredientObject = neo4j.CypherQuery(graph_db, query).execute()
							#If ingredient not exist in db
							if not ingredientObject:
								size=0
								ingredientObject, = graph_db.create({"name":ingredient[0] , "group":ingredient[1], "identificator":str(ingredient[2]), "size":1})
								numIngredients+=1
							#Exist
							else: 
								ingredientObject[0][0]["size"]+=1
								ingredientObject=ingredientObject[0][0]
							ingredientsRecipeList.append(ingredientObject)
							graph_db.create(rel(recipeNeo, "contiene", ingredientObject))
							graph_db.create(rel(ingredientObject, "pertenece a", recipeNeo))
						countMatrix=1
						for ingredientA in ingredientsRecipeList:
							for ingredientB in ingredientsRecipeList[countMatrix:]:
								countMatrix+=1
								graph_db.create(rel(ingredientA, "relaciona", ingredientB))
								graph_db.create(rel(ingredientB, "relaciona", ingredientA))
						print "Recipe graph saved"

				urls = self.getAllUrlsLxml(tree)
				urls = self.addAndCleanUrlsToParse(urls, totalObtainedUrls, urlsToParse)
				totalObtainedUrls = urls[0]
				urlsToParse = urls[1]
			except:
				print "URL ERROR2"
				totalObtainedUrls[urlPagina]=0

	#This method get the domain from a url
	def getDomain(self,url):
		if 'http://' in url[:7]:
		    url=url[7:]
		if 'www.' in url[:4]:
		    url=url[4:]
		if '/' in url[-1]:
		    url=url[:-1]
		return url
		
	def cleanCrudeRecipes(self):
		graph_db = neo4j.GraphDatabaseService()
		countRecipes = len(CrudeRecipe.objects.all())
		for crude in CrudeRecipe.objects.all():	
			recipe, = graph_db.create({"name": crude.name, "url": crude.url})
			print countRecipes," recipes left"
			countRecipes-=1
			ingredientsRecipeList = list()
			for ingredient in self.getIngredientsFromRecipe(crude.ingredients):
				query = "MATCH (n) WHERE n.identificator = '"+str(ingredient[2])+"' RETURN n"
				ingredientObject = neo4j.CypherQuery(graph_db, query).execute()
				#If ingredient not exist in db
				if not ingredientObject:
					ingredientObject, = graph_db.create({"name":ingredient[0] , "group":ingredient[1], "identificator":str(ingredient[2]), "size":1})
				else:
					ingredientObject[0][0]["size"]+=1
					ingredientObject=ingredientObject[0][0]
				ingredientsRecipeList.append(ingredientObject)
				graph_db.create(rel(recipe, "contiene", ingredientObject))
			countMatrix=1
			for ingredientA in ingredientsRecipeList:
				for ingredientB in ingredientsRecipeList[countMatrix:]:
					countMatrix+=1
					graph_db.create(rel(ingredientA, "relaciona", ingredientB))	
					graph_db.create(rel(ingredientB, "relaciona", ingredientA))

	def getIngredientsFromRecipe(self,recipe):
		ingredients=[]
		for recipeLine in recipe:
			for posibleIngredient in self.generateWords(recipeLine):
				posibleIngredient = posibleIngredient.lower()
				ingredientSingular=IngredientsList.objects.filter(spanishName=posibleIngredient)
				ingredientPlural = IngredientsList.objects.filter(spanishName=(posibleIngredient+'s'))
				ingredient= IngredientsList.objects.filter(spanishName=posibleIngredient[:-1])
				if ingredientSingular:
					ingredients.append((posibleIngredient,ingredientSingular[0].group, ingredientSingular[0].identificator))
					break
				elif ingredientPlural:
					ingredients.append((posibleIngredient,ingredientPlural[0].group, ingredientPlural[0].identificator))
					break
				elif ingredient:
					ingredients.append((posibleIngredient,ingredient[0].group, ingredient[0].identificator))
					break
		return ingredients


	def generateWords(self,recipeLine):
		recipeWords = recipeLine.split(" ")
		generatedWords=[]
		for i in xrange(len(recipeWords)-3):
			generatedWords.append(' '.join(recipeWords[i:i+4]))
		for i in xrange(len(recipeWords)-2):
			generatedWords.append(' '.join(recipeWords[i:i+3]))
		for i in xrange(len(recipeWords)-1):
			generatedWords.append(' '.join(recipeWords[i:i+2]))
		for i in xrange(len(recipeWords)):
			generatedWords.append(' '.join(recipeWords[i:i+1]))
		return generatedWords

	def stopParser(self):
		self.exitProces = True
		#self.erase()

	def parseItemsLxml(self, tree):
		#MultipleXapth
		"""
		xpathCount = 0
		item = None
		while item == None and xpathCount < len(self.xpath):
			try:
				item = tree.xpath(self.xpath[xpathCount])
			except:
				item = None
			if len(item)>0 and item!=None:
				return item
			xpathCount+=1
		return None
		"""
		#SimpleXpath
		try:
			item = tree.xpath(self.xpath[-1])
		except:
			item = None
		if len(item)>0 and item!=None:
			return item
		return None


	def getAllUrlsLxml(self, tree):
		urls = tree.xpath("//a/@href")
		urls = self.reFormarUrls(urls)
		#urls = self.cleanUrls(urls)
		return urls

	def addAndCleanUrlsToParse(self, urls, totalObtainedUrls , urlsToParse):
		for url in urls:
			urlVisited = None
			if "?" in url:
				url = url[:url.index('?')]
			if "#" in url:
				url = url[:url.index('#')]
			try: urlVisited=totalObtainedUrls[url]
			except: pass
			if urlVisited==None:
				if url!=None:
					if len(url.split("/"))>2:
						if url[:7]!='http://' or self.domain in url[:11+len(self.domain)]:
							totalObtainedUrls[url]=1
							urlsToParse.append(url)
		return [totalObtainedUrls,urlsToParse]


	def reFormarUrls(self, urls):
		for i in xrange(len(urls)):
			try:
				urls[i]=urls[i].get('href')
			except:
				pass
		return urls

	def isValidUrl(self, url):
		return len(url.split("/"))>2

	def isUrlIndomain(self, url):
		if url[:7]!='http://':
			return True
		elif self.domain in url[:11+len(self.domain)]:
			return True


	def erase(self):
		del self

