# -*- coding: utf-8 -*-
from mongoengine import *
from py2neo import *
from models import *
from django.http import HttpResponse
import subprocess
import sys,pprint
import json
import random


def loadIngredientsListBD():
	IngredientsList.objects.all().delete()
	readIngredients(open('/var/log/foodnet/ingredientsFiles/AzucarChocolateYDerivados', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/BebidasNoLacteas', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/CarnicosYDerivados', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/CerealesYDerivados', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/Frutas', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/GrasasYAceites', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/HuevosYDerivados', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/LacteosYDerivados', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/LegumbresYFrutosSecos', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/Miscelanea', 'r'))
	readIngredients(open('/var/log/foodnet/ingredientsFiles/PescadoMariscoYDerivados', 'r'))
	print "IngredientsList successfully loaded "


#It restarts all data from mongoDb and reload IngredientsList data.
def eraseMongoData():
	CrudeRecipe.objects.all().delete()
	HtmlDocument.objects.all().delete()
	IngredientsList.objects.all().delete()
	print "Done"

def resetNeoDatabase():
	graph_db = neo4j.GraphDatabaseService()
	graph_db.clear()
	print "Done"

def getColorsDict():
	colorsDict={"AzucarChocolateYDerivados":"#FFFF99","BebidasNoLacteas":"#CCCCFF","CarnicosYDerivados":"#CC3300"
					,"CerealesYDerivados":"#CC6600","Frutas":"#CCFF33","GrasasYAceites":"#8F7200","HuevosYDerivados":"#FFCC00","LacteosYDerivados":"#FFFFFF"
					,"LegumbresYFrutosSecos":"#A34719","Miscelanea":"#99FFCC","PescadoMariscoYDerivados":"#3333CC"}
	return colorsDict


def readIngredients(dataFile):
	lastWordComa=""
	print dataFile.name
	f = dataFile.read().replace("\n","\t").split("\t")[:-1]
	for i in xrange(0,len(f),3):
		if "," in f[i+1]:
			f[i+1] = f[i+1][:f[i+1].index(',')]
			if "," in f[i+2]:
				f[i+2] = f[i+2][:f[i+2].index(',')]
			if not (lastWordComa == f[i+1]):
				lastWordComa=f[i+1]
				if not IngredientsList.objects(identificator=f[i]):
					ingredient = IngredientsList(identificator=f[i], spanishName =f[i+1].lower(), englishName=f[i+2].lower(), group=dataFile.name.split("/")[-1])
					ingredient.save()

		else: 
			if not IngredientsList.objects(identificator=f[i]):
				ingredient = IngredientsList(identificator=f[i], spanishName =f[i+1].lower(), englishName=f[i+2].lower(), group=dataFile.name.split("/")[-1])
				ingredient.save()

def updateGraphData():
	graph_db = neo4j.GraphDatabaseService()
	queryNodes = neo4j.CypherQuery(graph_db, "MATCH (n) WHERE HAS (n.group)  RETURN n")
	queryEdges = neo4j.CypherQuery(graph_db, "Match n-[r]-m  WHERE HAS (n.group) AND HAS (m.group) Return r")
	nodes = queryNodes.execute()
	edges = queryEdges.execute()
	print "Querys excecuted"
	bufferOutputNodes = list()
	bufferOutpuEdges = list()
	colorsDict = getColorsDict()
	x=0
	y=0
	e=0
	for node in nodes:
		bufferOutputNodes.append({"id":node[0]["identificator"], "label":node[0]["name"], "size":node[0]["size"], "x":random.randint(0,10), "y":random.randint(0,10), "color":colorsDict[node[0]["group"]]})
		x+=1
		y+=1
	for edge in edges:
		bufferOutpuEdges.append({"id":str(e), "source":edge[0].end_node["identificator"], "target":edge[0].start_node["identificator"]})
		e+=1
	jsonFile = open('/var/log/foodnet/graphData.json', 'w+')
	#jsonFile = open('/home/marc/Marc/Django-1.4.10/websites/foodNet/media/static/MAMBA_TEST.json', 'w+')
	jsonFile.write('{ "nodes" : '+json.dumps(bufferOutputNodes)+',\n "edges" : '+json.dumps(bufferOutpuEdges)+'\n}')
