from djangotoolbox.fields import EmbeddedModelField
from djangotoolbox.fields import ListField
from django import forms
from mongoengine import *
from neo4django.db import models
from django.conf import settings


class Person(models.NodeModel):
    name = models.StringProperty()
    age = models.IntegerProperty()

    friends = models.Relationship('self',rel_type='friends_with')

class OnlinePerson(Person):
    email = models.EmailProperty()
    homepage = models.URLProperty()

class EmployedPerson(Person):
    job_title = models.StringProperty(indexed=True)

class Pet(models.NodeModel):
    owner = models.Relationship(Person,
                                rel_type='owns',
                                single=True,
                                related_name='pets'
                               )
       
class HtmlDocument(Document):
	url = StringField(max_length=200)
	htmlContent = StringField()
	#meta = {"db_alias": "html"}

class CrudeRecipe(Document):
	url = StringField(max_length=200)
	name = StringField(max_length=100)
	ingredients = ListField()
	#meta = {"db_alias": "crudeRecipesDataBase"}


class IngredientsList(Document):
	identificator= IntField()
	spanishName= StringField(max_length=100)
	englishName= StringField(max_length=100)


